unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Velthuis.BigIntegers, Velthuis.Bigdecimals,
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons, Vcl.Imaging.pngimage;

type
  TForm1 = class(TForm)
    izEdit: TLabeledEdit;
    zEdit: TLabeledEdit;
    ibEdit: TLabeledEdit;
    bEdit: TLabeledEdit;
    iaEdit: TLabeledEdit;
    aEdit: TLabeledEdit;
    epsEdit: TLabeledEdit;
    PrecisionEdit: TLabeledEdit;
    Memo1: TMemo;
    CalcBtn: TBitBtn;
    procedure CalcBtnClick(Sender: TObject);
  private
    { Private 錾 }
    function inputcheck(var precision: integer): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
type
  combig = record
    r : bigdecimal;
    i : bigdecimal;
  end;

var
  zero, one : bigdecimal;      // 0, 1
  precisions : integer;        // L

//------------------------------  comprex calc-------------------------------------------

// x: combig dpcsɊۂ
function combiground(x : combig): combig;
begin
  result.r := x.r.RoundToPrecision(precisions);
  result.i := x.i.RoundToPrecision(precisions);
end;


// ComBigf̉Z
function cadd(a, b: comBig): ComBig;
begin
  result.r := a.r + b.r;
  result.i := a.i + b.i;
end;

{
// ComBigf̌Z
function csub(a, b: ComBig): ComBig;
begin
  result.r := a.r - b.r;
  result.i := a.i - b.i;
end;
}

// combig + bigdecimal
function caddb(a: combig; b:bigdecimal): combig;
begin
  result.r := a.r + b;
  result.i := a.i;
end;

{
// combig - bigdecimal
function csubb(a : combig; b: bigdecimal): combig;
begin
  result.r := a.r - b;
  result.i := a.i;
end;
}


// Combig bigdecimal̏Z
function cmulb(a: Combig; b: bigdecimal): ComBig;
begin
  result.r := a.r * b;
  result.i := a.i * b;
end;


// Combigf̏Z
function cmul(a, b: Combig): ComBig;
begin
  result.r := a.r * b.r - a.i * b.i;
  result.i := a.r * b.i + a.i * b.r;
  result := combiground(result);
end;

{
// Combig bigdecimal̏Z
function cdivb(a: Combig; b: bigdecimal): Combig;
begin
  if b <> Bigdecimal.Zero then begin
    result.r := a.r / b;
    result.i := a.i / b;
  end
  else begin
    result.r := Bigdecimal.Zero;
    result.i := Bigdecimal.Zero;
  end;
end;
}

// Combigf̏Z
function cdiv(a, b: Combig): Combig;
var
  bb, arbraibi, aibrarbi: Bigdecimal;
begin
  bb := b.r * b.r + b.i * b.i;
  arbraibi := a.r * b.r + a.i * b.i;
  aibrarbi := a.i * b.r - a.r * b.i;
  bb := bb.RoundToPrecision(precisions);
  arbraibi := arbraibi.RoundToPrecision(precisions);
  aibrarbi := aibrarbi.RoundToPrecision(precisions);

  if bb <> Bigdecimal.Zero then begin
    result.r := arbraibi / bb;
    result.i := aibrarbi / bb;
  end
  else begin
    result.r := Bigdecimal.Zero;
    result.i := Bigdecimal.Zero;
  end;
end;

// a:combig = b:combig
function caeqb(x, y : combig): boolean;
begin
  if (x.r = y.r) and (x.i = y.i) then result := true
                                 else result := false;
end;

// Combig̐Βl
function cabs(a : combig): bigdecimal;
var
  arh2, aih2 : bigdecimal;
  tmp : bigdecimal;
begin
  arh2 := a.r * a.r;
  aih2 := a.i * a.i;
  arh2 := arh2.RoundToPrecision(precisions);
  aih2 := aih2.RoundToPrecision(precisions);
  tmp := arh2 + aih2;
  result := bigdecimal.Sqrt(tmp, precisions);
end;

//------------------------------------------------------------------------------

// a, b, z 
// eps     l
// pre     L
// ans     
// ߂l   0  1 +  -1 -
function Confluent_Hypergeometri_of_first(aa, bb, zz: combig; eps : bigdecimal; var ans : combig): integer;
var
  a, b, z, czero, siguma, azsbnn : combig;
  az, bnn : combig;
  ap, bp, an, bn, zn : combig;
  np, nn , comabs : bigdecimal;
  n  : integer;
begin
  result := 0;
  czero.r := zero;                  // czero
  czero.i := zero;
  a := aa;                          // a
  b := bb;                          // b
  z := zz;                          // z
  ap := a;                          // (a) = a
  bp := b;                          // (b) = b
  np := one;                        // (n) = 1
  an := ap;                         // (a)n = (a);
  bn := bp;                         // (b)n = (b)
  nn := np;                         // n! = (n)
  zn := z;                          // z^n = z
  n := 1;
  siguma := czero;                  // =0
  azsbnn.r := one;
  azsbnn.i := zero;
  repeat
    az := cmul(an, zn);               // (a)n * z^n
    if caeqb(az, czero) then begin    // (a)n * z^n = 0
      break;
    end;
    if caeqb(bn, czero) then begin    // (b)n = 0
      az := cmul(cmul(ap, z), azsbnn);   // (a)nz^n/(b)'n  'n=n-1 azsbnn=(a)'nz^'n/(b)'n
      if az.r >= zero then result := 1
                      else result := -1;
      break;
    end;
    bnn := cmulb(bn, nn);             // (b)n * n!

    az := combiground(az);            // precisionsɊۂ
    bnn := combiground(bnn);          // precisionsɊۂ
    azsbnn := cdiv(az, bnn);          //  = ((a)n * z^n) / ((b)n * n!)
    siguma := cadd(siguma, azsbnn);   //  = + 

    ap.r := ap.r + one;               // a=a+1
    bp.r := bp.r + one;               // b=b+1
    np := np + one;                   // n=n+1
    an := cmul(an, ap);               // (a)n
    bn := cmul(bn, bp);               // (b)n
    zn := cmul(zn, z);                // z^n
    nn := nn * np;                    // n!

    an := combiground(an);            // (a)n  precisionsɊۂ
    bn := combiground(bn);            // (b)n  precisionsɊۂ
    zn := combiground(zn);            // z^n   precisionsɊۂ
    nn := nn.RoundToPrecision(precisions);    //n!  precisionsɊۂ

    comabs := cabs(azsbnn);            // comabs = |azsbnn|
    inc(n);
  until  (comabs <= eps) or (n > 10000);
  if result <> 0 then
    ans := az
  else
    ans := caddb(siguma, one);         //  + 1
  form1.Memo1.Lines.Append('loop = ' + inttostr(n));
end;

//------------------------------------------------------------------------------

// ͒l̍őlŏl̃`FbN
function inbigcheck(s, xtext: string): boolean;
const
  MAXSTR = '1000';
  MINSTR = '1e-100';
var
  max, min, x: bigdecimal;
begin
  result := false;
  try
    x := xtext;
  except
    on EConverterror do begin
      application.MessageBox(pchar(s + ' ̒lɊԈႢ܂B'), nil);
      exit;
    end;
  end;
  max := MAXSTR;
  min := MinSTR;
  if x.Abs(x) > max then begin
    application.MessageBox(pchar('abs(' + s + ')̒l傫܂B' + #13#10 +
                                              '}' + MAXSTR + 'xłB'),'',0);
    exit;
  end;
  if (x.Abs(x) < min) and (x.Abs(x) <> zero) then begin
    application.MessageBox(pchar('abs(' + s + ')̒l܂B' + #13#10 +
                                              '}' + MINSTR + 'xłB'),'',0);
    exit;
  end;
  result := true;
end;

// ̓`FbN
function TForm1.inputcheck(var precision: integer): boolean;
var
  chd: double;
  ch : integer;
begin
  result := false;
  if not inbigcheck('a ', aedit.Text) then exit;;
  if not inbigcheck('b ', bedit.Text) then exit;;
  if not inbigcheck('z ', zedit.Text) then exit;;
  if not inbigcheck('a̋', iaedit.Text) then exit;;
  if not inbigcheck('b̋', ibedit.Text) then exit;;
  if not inbigcheck('z̋', izedit.Text) then exit;;
  val(precisionedit.Text, precision, ch);
  if ch <> 0 then begin
    application.MessageBox('L ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if precision < 10 then begin
    application.MessageBox('L 10ȏɂĉB','',0);
    exit;
  end;
  if precision > 1000 then begin
    application.MessageBox('L 1000ȉɂĉB','',0);
    exit;
  end;
  val(epsedit.Text, chd, ch);
  if ch <> 0 then begin
    application.MessageBox('lɊԈႢ܂B','',0);
    exit;
  end;
  if chd < 1e-100 then begin
    application.MessageBox('l1e-100傫ĉB','',0);
    exit;
  end;
  if chd > 1e-1 then begin
    application.MessageBox('l1e-1菬B','',0);
    exit;
  end;
  result := true;
end;


//------------------------------------------------------------------------------

// ľ̃[
function ZeroErase(s : string): string;
const
  EP = 'e';
  ZC = '0';
  dt = '.';
var
  c : char;
  i, j, k, l : integer;
begin
  l := length(s);
  j := 1;
  for i := 1 to l do begin
    c := s[i];
    if c = EP then begin
      j := i - 1;
      break;
    end;
    j := i;
  end;
  result := '';
  if j < l then begin
    for i := l downto j + 1 do
    result := s[i] + result;
  end;
  K := 1;
  for i := j downto 1 do begin
    c := s[i];
    if c <> ZC then begin
      k := i;
      if c = DT then  k := k + 1;
      break;
    end;
  end;
  for i := k downto 1 do
    result := s[i] + result;
end;

// vZ
procedure TForm1.CalcBtnClick(Sender: TObject);
var
  a, b, z, ans : combig;
  eps : bigdecimal;
  f : integer;
begin
  if inputcheck(precisions) = false then exit;
  bigdecimal.DefaultPrecision := precisions;
  a.r := aedit.Text;
  a.i := iaedit.Text;
  b.r := bedit.Text;
  b.i := ibedit.Text;
  z.r := zedit.Text;
  z.i := izedit.Text;
  eps := epsedit.Text;

  zero := bigdecimal.Zero;
  one := bigdecimal.One;

  memo1.Clear;
  memo1.Lines.Append('P퍇^􉽊֐');
  f := Confluent_Hypergeometri_of_first(a, b, z, eps, ans);
  if f = 0 then begin
    ans.r := ans.r.RoundToPrecision(50);
    ans.i := ans.i.RoundToPrecision(50);
    if ans.r = zero then
      memo1.Lines.Append('0.0')
    else
      memo1.Lines.Append(ZeroErase(ans.r.ToString));
    if ans.i = zero then
      memo1.Lines.Append('0.0 i')
    else
      memo1.Lines.Append(ZeroErase(ans.i.ToString) + ' i');
  end
  else begin
    if ans.r > zero then memo1.Lines.Append('');
    if ans.r < zero then memo1.Lines.Append('-');
    if ans.i > zero then memo1.Lines.Append('+ i');
    if ans.i < zero then memo1.Lines.Append('- i');
  end;
end;


end.
